"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComponentPipelinePage = void 0;
const component_1 = require("@teambit/component");
const documenter_ui_heading_1 = require("@teambit/documenter.ui.heading");
const react_1 = __importStar(require("react"));
const component_ui_pipelines_component_pipeline_queries_1 = require("@teambit/component.ui.pipelines.component-pipeline-queries");
const component_ui_pipelines_artifacts_panel_1 = require("@teambit/component.ui.pipelines.artifacts-panel");
const component_ui_pipelines_component_pipeline_context_1 = require("@teambit/component.ui.pipelines.component-pipeline-context");
const base_ui_surfaces_split_pane_split_pane_1 = require("@teambit/base-ui.surfaces.split-pane.split-pane");
const react_flow_renderer_1 = __importStar(require("react-flow-renderer"));
const base_ui_surfaces_split_pane_hover_splitter_1 = require("@teambit/base-ui.surfaces.split-pane.hover-splitter");
const component_ui_pipelines_component_pipeline_utils_1 = require("@teambit/component.ui.pipelines.component-pipeline-utils");
const pipeline_node_1 = require("./pipeline-node");
const blank_state_1 = require("./blank-state");
const component_pipeline_page_module_scss_1 = __importDefault(require("./component-pipeline-page.module.scss"));
function ComponentPipelinePage({ host, fileIconMatchers }) {
    const component = (0, react_1.useContext)(component_1.ComponentContext);
    const { data } = (0, component_ui_pipelines_component_pipeline_queries_1.useComponentPipelineQuery)(host, component.id.toString());
    const nodes = (0, react_1.useMemo)(() => {
        if (!data)
            return [];
        const { tasks = [] } = data;
        return tasks.map((task, index) => {
            const duration = (0, component_ui_pipelines_component_pipeline_utils_1.calcDuration)(task.startTime, task.endTime);
            return {
                id: task.id,
                type: 'artifactNode',
                data: Object.assign(Object.assign({}, task), { duration }),
                position: { x: 50 + index * 300, y: 300 },
            };
        });
    }, [data]);
    const edges = (0, react_1.useMemo)(() => {
        if (!nodes || nodes.length < 2) {
            return [];
        }
        const _edges = [];
        for (let i = 1; i < nodes.length; i += 1) {
            const edge = {
                id: `${nodes[i - 1].id}_${nodes[i].id}`,
                source: nodes[i - 1].id,
                target: nodes[i].id,
                arrowHeadType: react_flow_renderer_1.ArrowHeadType.Arrow,
            };
            _edges.push(edge);
        }
        return _edges;
    }, [nodes]);
    const elements = [...nodes, ...edges];
    const totalDurationSecs = (0, react_1.useMemo)(() => {
        if (!data)
            return 0;
        const { tasks } = data;
        return tasks.reduce((agg, cur) => {
            return agg + (0, component_ui_pipelines_component_pipeline_utils_1.calcDuration)(cur.startTime, cur.endTime);
        }, 0);
    }, [data]);
    const NodeTypes = {
        artifactNode: pipeline_node_1.PipelineNode,
    };
    const [selectedPipelineId, setSelectedPipelineId] = (0, react_1.useState)(undefined);
    const sidebarOpenness = selectedPipelineId ? base_ui_surfaces_split_pane_split_pane_1.Layout.row : base_ui_surfaces_split_pane_split_pane_1.Layout.left;
    const showBlankState = elements.length === 0;
    const onPanelClicked = () => {
        setSelectedPipelineId(undefined);
    };
    return (react_1.default.createElement(component_ui_pipelines_component_pipeline_context_1.ComponentPipelineContext.Provider, { value: {
            pipeline: (data === null || data === void 0 ? void 0 : data.tasks) || [],
            selectedPipelineId,
            setSelectedPipelineId,
        } },
        react_1.default.createElement(react_flow_renderer_1.ReactFlowProvider, null,
            react_1.default.createElement("div", { className: component_pipeline_page_module_scss_1.default.page },
                react_1.default.createElement(documenter_ui_heading_1.H2, { size: "xs" }, "Pipeline"),
                !showBlankState && (react_1.default.createElement("div", { className: component_pipeline_page_module_scss_1.default.statContainer },
                    react_1.default.createElement("div", { className: component_pipeline_page_module_scss_1.default.statItem },
                        react_1.default.createElement("p", { className: component_pipeline_page_module_scss_1.default.statTitle }, "Duration"),
                        react_1.default.createElement("p", null,
                            (0, component_ui_pipelines_component_pipeline_utils_1.calcSeconds)(totalDurationSecs),
                            "s ",
                            (0, component_ui_pipelines_component_pipeline_utils_1.calcMilliseconds)(totalDurationSecs),
                            "ms")),
                    react_1.default.createElement("div", { className: component_pipeline_page_module_scss_1.default.statItem },
                        react_1.default.createElement("p", { className: component_pipeline_page_module_scss_1.default.statTitle }, "Status"),
                        react_1.default.createElement("p", null, data === null || data === void 0 ? void 0 : data.buildStatus)))),
                react_1.default.createElement(base_ui_surfaces_split_pane_split_pane_1.SplitPane, { size: '75%', className: component_pipeline_page_module_scss_1.default.graphContainer, layout: sidebarOpenness },
                    react_1.default.createElement(base_ui_surfaces_split_pane_split_pane_1.Pane, null,
                        !showBlankState && (react_1.default.createElement(react_flow_renderer_1.default, { draggable: false, nodesDraggable: false, selectNodesOnDrag: false, nodesConnectable: false, zoomOnDoubleClick: false, elementsSelectable: true, maxZoom: 1, nodeTypes: NodeTypes, elements: elements, className: component_pipeline_page_module_scss_1.default.graph, onPaneClick: onPanelClicked },
                            react_1.default.createElement(react_flow_renderer_1.Background, null),
                            react_1.default.createElement(react_flow_renderer_1.Controls, { className: component_pipeline_page_module_scss_1.default.controls }))),
                        showBlankState && react_1.default.createElement(blank_state_1.ComponentPipelineBlankState, null)),
                    (selectedPipelineId && react_1.default.createElement(base_ui_surfaces_split_pane_hover_splitter_1.HoverSplitter, null)) || react_1.default.createElement(react_1.default.Fragment, null),
                    (selectedPipelineId && (react_1.default.createElement(base_ui_surfaces_split_pane_split_pane_1.Pane, null,
                        react_1.default.createElement(component_ui_pipelines_artifacts_panel_1.ArtifactPanel, { fileIconMatchers: fileIconMatchers })))) || react_1.default.createElement(react_1.default.Fragment, null))))));
}
exports.ComponentPipelinePage = ComponentPipelinePage;
//# sourceMappingURL=component-pipeline-page.js.map